#include "QuartetTable.h"

//// construtor. number is the total number of quartets
CQuartetTable::CQuartetTable(int number)
{
    int i,j,k;

    labelNum=number;

    quartets = (UNSIGNCHAR ****)malloc( (labelNum+1)*sizeof(UNSIGNCHAR ***) );
    for (i=1;i<=labelNum;i++)
      quartets[i]=(UNSIGNCHAR ***)malloc( (labelNum+1)*sizeof(UNSIGNCHAR **) );
    for (i=1;i<=labelNum;i++)
      for (j=i+1;j<=labelNum;j++)
         quartets[i][j]=(UNSIGNCHAR **)malloc( (labelNum+1)*sizeof(UNSIGNCHAR *) );
    for (i=1;i<=labelNum;i++)
      for (j=i+1;j<=labelNum;j++)
        for (k=i+1;k<=labelNum;k++)
	       quartets[i][j][k]=(UNSIGNCHAR *)calloc( labelNum+1, sizeof(UNSIGNCHAR) );


    names = (char **)malloc((labelNum +1)*sizeof(char*) );
    for (i=1;i<=labelNum;i++)
      names[i]=(char *)calloc(MAXLENGTH, sizeof (char));

    distance = (float **)malloc((labelNum +1)*sizeof(float*) );
    for (i=1;i<=labelNum;i++)
      distance[i]=(float *)calloc((labelNum +1),sizeof(float));

     total=0;
}


CQuartetTable::CQuartetTable()
{
	total=0;
}


UNSIGNCHAR CQuartetTable::GetValue(UNSIGNCHAR i, UNSIGNCHAR j, UNSIGNCHAR k, UNSIGNCHAR l)
{
	return quartets[i][j][k][l];
}


CQuartetTable::~CQuartetTable()
{
   int i,j,k;

    for (i=1;i<=labelNum;i++)
      for (j=i+1;j<=labelNum;j++)
        for (k=i+1;k<=labelNum;k++)
             free (quartets[i][j][k]);
    for (i=1;i<=labelNum;i++)
      for (j=i+1;j<=labelNum;j++)
         free(quartets[i][j]);

     for (i=1;i<=labelNum;i++)
         free(quartets[i]);
 	free(quartets);
 	
 	if (names)
 	{
 	for (i=1;i<=labelNum;i++)
 	  free(names[i]);
 	free(names); 
    }
}

void CQuartetTable::SetLabelNum(UNSIGNCHAR number)
{
   int i,j,k,l;

   labelNum=number;

    quartets = (UNSIGNCHAR ****)malloc( (labelNum+1)*sizeof(UNSIGNCHAR ***) );
    for (i=1;i<=labelNum;i++)
      quartets[i]=(UNSIGNCHAR ***)malloc( (labelNum+1)*sizeof(UNSIGNCHAR **) );
    for (i=1;i<=labelNum;i++)
      for (j=i+1;j<=labelNum;j++)
         quartets[i][j]=(UNSIGNCHAR **)malloc( (labelNum+1)*sizeof(UNSIGNCHAR *) );
     for (i=1;i<=labelNum;i++)
        for (j=i+1;j<=labelNum;j++)
          for (k=i+1;k<=labelNum;k++)
	         quartets[i][j][k]=(UNSIGNCHAR *)calloc( labelNum+1, sizeof(UNSIGNCHAR) );


}

int CQuartetTable::Insert(UNSIGNCHAR q[4], UNSIGNCHAR weight)
{
    if (quartets[q[0]][q[1]][q[2]][q[3]]==0)
    {
       quartets[q[0]][q[1]][q[2]][q[3]] = weight;
       total++;
       return 1;
    }
    else
      return 0;
}

void CQuartetTable::compare(UNSIGNCHAR a, UNSIGNCHAR b, UNSIGNCHAR *small, UNSIGNCHAR *big)
{
	if (a>b)
	{
		*big=a;
		*small=b;
	}
	else
	{
		*big=b;
		*small=a;
	}
}

void CQuartetTable::CheckChangeHistory(UNSIGNCHAR *change_history,int error_num)
{
	int i,count=0;
    UNSIGNCHAR a,b,c,d,small_bd,big_bd,small_bc,big_bc;

	i=0;
	while (change_history[i]>0)
	{
		a=change_history[i];
		b=change_history[i+1];
		c=change_history[i+2];
		d=change_history[i+3];
		compare(b,c,&small_bc,&big_bc);
		compare(b,d,&small_bd,&big_bd);

		if (quartets[a][b][c][d]+quartets[a][c][small_bd][big_bd]+quartets[a][d][small_bc][big_bc]!=1)
		{
			printf("set error for [%d,%d|%d,%d]\n",a,b,c,d);
			getchar();
		}
		if (quartets[a][b][c][d]==0)
		{
			printf("set error1 for [%d,%d|%d,%d]\n",a,b,c,d);
			getchar();

		}
        i=i+4;
        count++;
	}
	if (count!=error_num)
	{
		printf("match error count=%d, error_num=%d \n",count,error_num);
		getchar();

	}
		//printf("copy finished\n");

}

void CQuartetTable::Update(UNSIGNCHAR *change_history)
{
	int i;
    UNSIGNCHAR a,b,c,d,small_bd,big_bd,small_bc,big_bc;

	i=0;
	while (change_history[i]>0)
	{
		a=change_history[i];
		b=change_history[i+1];
		c=change_history[i+2];
		d=change_history[i+3];
		compare(b,c,&small_bc,&big_bc);
		compare(b,d,&small_bd,&big_bd);

		/*if (quartets[a][b][c][d]+quartets[a][c][small_bd][big_bd]+quartets[a][d][small_bc][big_bc]!=1)
		   printf("set error for [%d,%d|%d,%d]\n",a,b,c,d);*/

		if (quartets[a][b][c][d]==1)
		{
				i=i+4;
				continue;
			   //printf("already changed, [%d,%d|%d,%d]\n",a,b,c,d);
		}
		else if (quartets[a][c][small_bd][big_bd]==1)
		{
				quartets[a][c][small_bd][big_bd]=0;
				quartets[a][b][c][d]=1;
		}
		else //if (quartets[a][d][small_bc][big_bc]==1)
		{
				quartets[a][d][small_bc][big_bc]=0;
				quartets[a][b][c][d]=1;
		}
	//	else
	//	{
	//    		printf("not exist!,[%d,%d|%d,%d]\n",a,b,c,d);
	//    		char ch=getchar();
	//	}
	    i=i+4;

	}
		//printf("copy finished\n");

}


int CQuartetTable::Compare(CQuartetTable *source)
{
   UNSIGNCHAR i,j,k,l,q[4];
   int count=0  ;

   for (i=1;i<=labelNum-3;i++)
     for (j=i+1;j<=labelNum-2;j++)
       for (k=j+1;k<=labelNum-1;k++)
         for (l=k+1;l<=labelNum;l++)
         {
            source->find(i,j,k,l,q);
	        if (quartets[q[0]][q[1]][q[2]][q[3]]==0)
	        {
	          //printf("(%d,%d|%d,%d) in source is different ",q[0],q[1],q[2],q[3]);
	          //getchar();
	         count++;
	        }
         }
   printf("\ntotal difference=%d\n",count);
   return count;
}


void CQuartetTable::Copy(CQuartetTable *source)
{
   UNSIGNCHAR i,j,k,l;
   for (i=1;i<=labelNum-3;i++)
      for (j=i+1;j<=labelNum-2;j++)
        for (k=j+1;k<=labelNum-1;k++)
          for (l=k+1;l<=labelNum;l++)
            quartets[i][j][k][l]=source->GetValue(i,j,k,l);
       	    

}
/*
void CQuartetTable::ChangeQuartet(char old_q[4],char new_q[4])
{
	char ch;

	if (quartets[old_q[0]][old_q[1]][old_q[2]][old_q[3]]==0)
	{
	  printf("cannot change! old:[%d,%d|%d,%d] new:[%d,%d,%d,%d]\n",
	          old_q[0],old_q[1],old_q[2],old_q[3],
	          new_q[0],new_q[1],new_q[2],new_q[3]);
	  ch=getchar();
    }
	else if  (quartets[new_q[0]][new_q[1]][new_q[2]][new_q[3]]==1)
	{
	  printf("already changeold:[%d,%d|%d,%d] new:[%d,%d,%d,%d]\n",
	          old_q[0],old_q[1],old_q[2],old_q[3],
	          new_q[0],new_q[1],new_q[2],new_q[3]);
	      		ch=getchar();
			}

	else
	{
		quartets[old_q[0]][old_q[1]][old_q[2]][old_q[3]]=0;
		quartets[new_q[0]][new_q[1]][new_q[2]][new_q[3]]=1;
	}
}
*/

void CQuartetTable::ChangeQuartet(UNSIGNCHAR old_q[4],UNSIGNCHAR new_q[4])
{
	quartets[old_q[0]][old_q[1]][old_q[2]][old_q[3]]=0;
	quartets[new_q[0]][new_q[1]][new_q[2]][new_q[3]]=1;
}



int CQuartetTable ::LoadFromFile(char *filename)
{
  int i,j,k;
  char line[MAXILABEL*5], currentword[5];
  UNSIGNCHAR quartet[4],conflict[4];
  int max_loaded_label=0,tmp;
  UNSIGNCHAR confidence,weight;

  FILE *stream;
  
    for (i=1;i<=labelNum;i++)
     sprintf(names[i],"%d",i);
  
  if( (stream = fopen( filename, "r+t" )) == NULL )
  {
		printf( "ERROR! Read quartets from %s\n", filename );
		return 0;
  }
  else
	printf( "Load quartets from %s\n", filename );

  int count=0;
  int exist_count=0;
  int conflict_count=0;
  for (i=0;i<4;i++)
	quartet[i]=0;

  while(!feof(stream))
  {
	  memset(line,0,MAXILABEL*5);

	  if (fgets( line, MAXILABEL*5, stream ) == NULL)
	  {
		  if (!feof(stream))
			 printf( "fgets error!!!\n" );
		  break;
	  }

	  if (strlen(line)<3)
		continue;
      if (line[0]=='%')
        continue;

	  for (i=0;i<4;i++)
		 quartet[i]=0;
	  i=0;
	  j=0;
	  k=0;

	  confidence=50; ///default values
	  weight=1;
	  memset(currentword,0,5);
	  while( i<=(int)strlen(line) )
	  {
		  if ((line[i]>='0') && (line[i]<='9') )
			   currentword[j++]=line[i];
		  else if (j>0)   /// met with a delimiter
		  {
			  if (k<4)  //// the number is a label number
			  {
				  quartet[k]=atoi(currentword);
				  if (quartet[k]>max_loaded_label)
					 max_loaded_label=quartet[k];
			  }
			  else if (k==4)   /// the number is the confidence
			  {
				  weight=atoi(currentword);
			  }
			  else if (k==5)
			  {
				  confidence=atoi(currentword);
			  }
			  else
				printf("k=%d,currentword=%s,line=%s,weight=%d,confidence=%d\n",k,currentword,line,weight,confidence);
			  k++;
			  j=0;
			  memset(currentword,0,5);
		  }
		  i++;
	  }


	 //printf("read in: %d,%d|%d,%d:%d  ",quartet[0],quartet[1],quartet[2],quartet[3],confidence);

	 if( (quartet[0]==quartet[1])||(quartet[0]==quartet[2])||(quartet[0]==quartet[3])||
		 (quartet[1]==quartet[2])||(quartet[1]==quartet[3])||(quartet[2]==quartet[3]))

	 {
		 printf("read in ERROR: %d,%d|%d,%d:%d:%d  ",quartet[0],quartet[1],quartet[2],quartet[3],weight,confidence);
		 getchar();
	 }

	 //bool changed=false;
	  if (quartet[0]> quartet[1])
	  {
		  tmp=quartet[0];
		  quartet[0]=quartet[1];
		  quartet[1]=tmp;
		 // changed=true;
	  }

	  if (quartet[2]> quartet[3])
	  {
		  tmp=quartet[2];
		  quartet[2]=quartet[3];
		  quartet[3]=tmp;
		  //changed=true;
	  }

	  if (quartet[0]>quartet[2])
	  {
		  tmp=quartet[0];
		  quartet[0]=quartet[2];
		  quartet[2]=tmp;
		  tmp=quartet[1];
		  quartet[1]=quartet[3];
		  quartet[3]=tmp;
		  //changed=true;
	  }


	 UNSIGNCHAR findresult=quartets[quartet[0]][quartet[1]][quartet[2]][quartet[3]];



	 if (findresult==0)
	 {
		 quartets[quartet[0]][quartet[1]][quartet[2]][quartet[3]]=1;
    	 count++;
	 }
	 else if (findresult==1)
	 {
		 printf("%d,%d|%d,%d  exists\n",quartet[0],quartet[1],quartet[2],quartet[3]);
		 exist_count++;
	 }
	 confidence=0;
 }

 if (labelNum!=max_loaded_label)
	labelNum=max_loaded_label;


 printf ("total %d quartets, %d labels.\nquartettable loaded quartets=%d\nconflict_list loaded quartet=%d\nrepeated quartet =%d\n",
		  count+exist_count+conflict_count,labelNum, count,conflict_count, exist_count);
 fclose(stream);
 return labelNum;

}

int CQuartetTable::find(UNSIGNCHAR *quartet)
{
	return quartets[quartet[0]][quartet[1]][quartet[2]][quartet[3]];
}

int CQuartetTable::find(UNSIGNCHAR *quartet, UNSIGNCHAR *conflict)
{
	//int i;
	UNSIGNCHAR a,b,c,d;
	UNSIGNCHAR big_bd, small_bd, big_bc, small_bc;

	a=quartet[0];
	b=quartet[1];
	c=quartet[2];
	d=quartet[3];

	if (quartets[a][b][c][d]>=1)
	{
		conflict[0]=a;
		conflict[1]=b;
		conflict[2]=c;
	    conflict[3]=d;
		return 1;
	}
	else
	{
		compare(b,c,&small_bc,&big_bc);
		compare(b,d,&small_bd,&big_bd);

		if (quartets[a][c][small_bd][big_bd]>=1)
		{
			conflict[0]=a;
			conflict[1]=c;
			conflict[2]=small_bd;
			conflict[3]=big_bd;
			return 2;
		}

		if (quartets[a][d][small_bc][big_bc]>=1)
		{
			conflict[0]=a;
			conflict[1]=d;
			conflict[2]=small_bc;
			conflict[3]=big_bc;
			return 2;
		}
	}
	return 0;
}



int CQuartetTable::find(UNSIGNCHAR a, UNSIGNCHAR b,UNSIGNCHAR c, UNSIGNCHAR d, UNSIGNCHAR *conflict)
{
	//int i;
	UNSIGNCHAR big_bd, small_bd, big_bc, small_bc;

	if (quartets[a][b][c][d]==1)
	{
		conflict[0]=a;
		conflict[1]=b;
		conflict[2]=c;
	    conflict[3]=d;
		return 1;
	}
	else
	{
		compare(b,c,&small_bc,&big_bc);
		compare(b,d,&small_bd,&big_bd);

		if (quartets[a][c][small_bd][big_bd]==1)
		{
			conflict[0]=a;
			conflict[1]=c;
			conflict[2]=small_bd;
			conflict[3]=big_bd;
			return 2;
		}

		if (quartets[a][d][small_bc][big_bc]==1)
		{
			conflict[0]=a;
			conflict[1]=d;
			conflict[2]=small_bc;
			conflict[3]=big_bc;
			return 2;
		}
	}
	return 0;
}


    /////save the quartet into file
void CQuartetTable::save(char *filename)
{
	 UNSIGNCHAR q[4];
	 UNSIGNCHAR i,j,k,l,m;

	 FILE *stream;
	 if( (stream = fopen( filename, "w+t" )) == NULL )
	 {
			printf( "ERROR! Write Quartets to %s\n", filename );
			return;
	 }
	 else
			printf( "Writing Quartets to %s\n", filename );

    for (i=1;i<=labelNum-3;i++)
	  for (j=i+1;j<=labelNum-2;j++)
	    for (k=j+1;k<=labelNum-1;k++)
	      for (l=k+1;l<=labelNum;l++)
	        {
				if (find(i, j, k, l,  q)==0)
					 printf("find error!!(%d,%d,%d,%d)\n",i,j,k,l);
				fprintf(stream,"%d,%d|%d,%d\n",q[0],q[1],q[2],q[3]);
			}

	 fclose(stream);


}



//// add the label into the labelSet, return the new least common ancestor
/// of all the added labels
int CQuartetTable::AddLabel(UNSIGNCHAR label, CBitLabelSet *labelSet, int *edges, int lca, int rootLabel)
{
    int parent;
    if (labelSet->In(label))  ////already in the labelset
       return lca;
    labelSet->Add(label);   /// add
    if (lca ==rootLabel)   ////lca is the root, no need to compute lca
      return lca;
    if (lca==0)    /// first time to add, lca is the internal node connect that leaf
      return edges[label];

    if (edges[label]==edges[lca]) /// one more upper, at the same side of root
      return edges[label];

    parent=edges[label];  ///parent of label
    while ((parent !=lca) && (parent!=rootLabel))
       parent=edges[parent];
    if (parent==lca) ///inside
      return lca;

    parent=edges[lca]; ///parent of lca
    while ((parent !=edges[label]) && (parent!=rootLabel))
       parent=edges[parent];

    //if (parent==edges[label]) ///outside
      return parent;  ///outside
    //else
      //return
}




void CQuartetTable::ToBracketTree()
{

	int currentLabel,parent,newLabel;
	UNSIGNCHAR q[4];
	UNSIGNCHAR i,j,k,l,addedLeaf;
	int *edges;
    int rootLabel = 2*labelNum-1;
    int lcaLeft, lcaRight;


	CBitLabelSet *leftLabelSet= new CBitLabelSet(labelNum);
    CBitLabelSet *rightLabelSet= new CBitLabelSet(labelNum);

    //// suppose labelNum=n
    ///edges[1]---edges[n] , the internal node connected
	/// with the leaf node       (n edges)
	///  edges[n+1]-----edges[n+n-2]
	///  the edges connecting internal nodes
	/// there are n-2 internal nodes (except root)
	//  root is defined as 2n-1
	///  and n-3 edges
	/// then edges 1---2n-2,  total alloc 2n-1 memory
	///
	edges = (int *) calloc (2*labelNum-1,sizeof(int));
//	memset(edges,0,(2*labelNum-1)*sizeof(int));


	//// initialize the edges for the first quartet
	find(1,2,3,4,q);
	edges[q[0]]=labelNum+1;
    edges[q[1]]=labelNum+1;
    edges[q[2]]=labelNum+2;
    edges[q[3]]=labelNum+2;
    edges[labelNum+1]=rootLabel; //// root in the middle
    edges[labelNum+2]=rootLabel; ///  root in the middle
/*
q[0]        q[2]
    \_______/
    /       \
q[1]        q[3]
*/

    //// add labels (start from 5) one by one
	for (currentLabel=5;currentLabel<=labelNum;currentLabel++)
	{
		leftLabelSet->Clear();
		rightLabelSet->Clear();
		lcaLeft=0;
		lcaRight=0;

	    /// initialize the leftLabel set with 1,2,3,currentLabel
        find(1,2,3,currentLabel,q);
        if  (q[1]==currentLabel)   /// q[2],q[3] at the same side
        {
            lcaLeft=AddLabel(q[2], leftLabelSet, edges, lcaLeft, rootLabel);
            lcaLeft=AddLabel(q[3], leftLabelSet, edges, lcaLeft, rootLabel);
        }
        else
        {
            lcaLeft=AddLabel(q[0], leftLabelSet, edges, lcaLeft, rootLabel);
            lcaLeft=AddLabel(q[1], leftLabelSet, edges, lcaLeft, rootLabel);
        }

    	for (i=1;i<=currentLabel-3;i++)
		  for (j=i+1;j<=currentLabel-2;j++)
		    for (k=j+1;k<=currentLabel-1;k++)
		    {
                if (leftLabelSet->GetSize()==currentLabel-2)
                   goto outside;
                  // break;
				find(i,j,k,currentLabel,q);
				if (q[1]==currentLabel)   /// q[2],q[3] at the same side
				{
					if (leftLabelSet->In(q[2])) /// q[2] in the left side
					   lcaLeft=AddLabel(q[3], leftLabelSet, edges, lcaLeft, rootLabel);
                    else if (leftLabelSet->In(q[3])) /// q[3] in the left side
                       lcaLeft=AddLabel(q[2], leftLabelSet, edges, lcaLeft, rootLabel);
				}
				else       ///q[0],q[1] at the same side
				{
					if (leftLabelSet->In(q[0])) /// q[0] in the left side
					   lcaLeft=AddLabel(q[1], leftLabelSet, edges, lcaLeft, rootLabel);
                    else if (leftLabelSet->In(q[1])) /// q[1] in the left side
                       lcaLeft=AddLabel(q[0], leftLabelSet, edges, lcaLeft, rootLabel);
                }
			}/// end for
outside:

        for (i=1;i<=currentLabel-1;i++)
          if (leftLabelSet->In(i)==0)
          {
              lcaRight=AddLabel(i, rightLabelSet, edges, lcaRight, rootLabel);
              addedLeaf=i;
          }


        printf("add %d, lcaleft=%d, lcaright=%d\n",currentLabel,lcaLeft,lcaRight);
        printf("left= ");
        leftLabelSet->Display();
        printf("right= ");
        rightLabelSet->Display();


        newLabel= labelNum+currentLabel-2;

        if ((lcaLeft==rootLabel)&& (lcaRight==rootLabel))
             printf("error!");
        if (lcaLeft<rootLabel) /// left side
        {
            edges[newLabel]=edges[lcaLeft];
            edges[currentLabel]=newLabel;
            edges[lcaLeft]=newLabel;
        }
        else if (rightLabelSet->GetSize()==1)  /// right side, sibling
        {
            edges[newLabel]=lcaRight;
            edges[currentLabel]=newLabel;
            edges[addedLeaf]=newLabel;
        }
        else ///right side, non sibling
        {
            edges[newLabel]=edges[lcaRight];
            edges[currentLabel]=newLabel;
            edges[lcaRight]=newLabel;

	    }

    }/// end for currentlabel
	for (i=1;i<=2*labelNum-2;i++)
    	printf("(%d, %d) ",i, edges[i]);

}



/*
     /// disply all the quartet in the list.
void CHashTable::display()
{
	struct Quartet *node;
	if (head->next==0)
	    sort();
	node=head->next;
	while (node!=0)
	{
		printf("%d,%d|%d,%d:%d:%d\n",node->labels[0],node->labels[1],node->labels[2],node->labels[3],node->weight,node->confidence);
		node=node->next;
	}
}



*/
/// given four labels of a quartet ab|cd, format them to a standard quartet.
/// that is  a<b, c<d, and a<c. save the formatted quartet to quartet[4]
void CQuartetTable::formquartet(UNSIGNCHAR a,UNSIGNCHAR b,UNSIGNCHAR c,UNSIGNCHAR d,UNSIGNCHAR *quartet)
{

  if (a>b)
  {
	 quartet[0]=b;
	 quartet[1]=a;
   }
   else
   {
	  quartet[0]=a;
	  quartet[1]=b;
   }

   if (c>d)
   {
	 quartet[2]=d;
	 quartet[3]=c;
   }
   else
   {
	  quartet[2]=c;
	  quartet[3]=d;
   }

   if (quartet[0]>quartet[2])
   {
	   exchange(&quartet[0],&quartet[2]);
	   exchange(&quartet[1],&quartet[3]);
   }

}
void CQuartetTable::exchange(UNSIGNCHAR *a, UNSIGNCHAR *b)
{
	UNSIGNCHAR tmp;
  	tmp=*a;
  	*a=*b;
  	*b=tmp;
}

char * CQuartetTable::GetLabelName(UNSIGNCHAR label)
{
    return names[label];
};


void  CQuartetTable::LoadFromDistanceMatrix(char * filename)
{
   FILE *streamIn;
   char *line,*cur, *dest,length,word[MAXLENGTH];
   int quartetNum;
   int i,j;

   streamIn = fopen( filename, "r+t" );

   line = (char *)calloc(MAXLENGTH*(labelNum+1),sizeof(char));
   fgets(line,10,streamIn);
   labelNum=atoi(line);
   printf("number of species: %d\n",labelNum);

   i=1;j=0;
   while(!feof(streamIn))
   {
    	memset(line,0,MAXLENGTH*(labelNum+1));
      	if (fgets( line, MAXLENGTH*(labelNum+1), streamIn ) == NULL)
      	{
			if (!feof(streamIn))
	  		   printf( "fgets error!!!\n" );
	  		break;
      	}
      	if (strlen(line)<2)
      	  continue;
        cur =line;

         while ( (cur[0]!=0) && (cur[0]!='\n') && (cur[0]!=0x0A) )
         {
		   while((cur[0]==' ')||(cur[0]=='\t'))  /// ignore any space
			  cur++;

			   /// move dest forward until next blank space
		   dest=cur;
		   while ( (dest[0]!=' ')&& (dest[0]!='\t')&&(dest[0]!=0) && (dest[0]!='\n'))
				dest++;

	       if (dest[0]==0)
				  break;
				/// calculate the length of this string (between two space)
		   length = (int)(dest - cur );
		   if (length<=1)
		     break;

		   memset(word,0,MAXLENGTH);
		   memcpy(word,cur,length);
		   if (j==0)
		   {
				    //printf("\n%s\n",word);
                        memcpy(names[i],cur,length);
                        j++;
		   }
		   else
		   {
				   //printf("(%s, %d),",word,j);
				   if (j<=labelNum)
    				   distance[i][j]= (float) atof(word);
    				else
    				  	printf("\nj=%d,Error  ",j);
				   j++;

		   }
		   cur=dest;
	   }
	   i++;
	   j=0;
    }
	fclose(streamIn );
	free(line);
  
}


void CQuartetTable:: GenerateQuartet_FourPoint()
{
       float minDistance,Dijkl,Dikjl,Diljk;
       int i,j,k,l;
	   for (i=1;i<=labelNum;i++)
	     for (j=i+1;j<=labelNum;j++)
	        for (k=j+1;k<=labelNum;k++)
	           for (l=k+1;l<=labelNum;l++)
	           {
				   Dijkl=distance[i][j]+distance[k][l];
				   Dikjl=distance[i][k]+distance[j][l];
				   Diljk=distance[i][l]+distance[j][k];
				   if (Dijkl<Dikjl)
				      minDistance=Dijkl;
				   else
				      minDistance=Dikjl;

				   if (Diljk<minDistance)
				      minDistance=Diljk;

	               if (Dijkl==minDistance)
                      quartets[i][j][k][l]=1;
	               else if (Dikjl==minDistance)
	                  quartets[i][k][j][l]=1;
                   else if (Diljk==minDistance)
                       quartets[i][l][j][k]=1;
	               else
	                  printf("error!!!!\n");
                }
                
                
    
 }

void CQuartetTable::ClearTable()
{
   int i,j,k,l; 
   for (i=1;i<=labelNum-1;i++)
     for (j=i+1;j<=labelNum;j++)
       for (k=i+1;k<=labelNum-1;k++)
         for (l=k+1;l<=labelNum;l++)
            quartets[i][j][k][l]=0;
}
void  CQuartetTable::IncreaseWeight(UNSIGNCHAR *quartet, UNSIGNCHAR weight)
{
   quartets[quartet[0]][quartet[1]][quartet[2]][quartet[3]]+=weight;
}
